import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.layout.StackPane;
import javafx.scene.Scene;
import javafx.scene.paint.Color;
import javafx.application.Platform;
import javafx.scene.Group;
import javafx.scene.SubScene;
import javafx.scene.PerspectiveCamera;
import javafx.scene.PointLight;
import javafx.scene.AmbientLight;
import javafx.scene.shape.Box;
import javafx.scene.shape.Cylinder;
import javafx.scene.shape.Sphere;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.paint.Color;
import javafx.scene.transform.Rotate;

public class JavaFX3DObj3 extends Application {

	/**
	 * s
	 * <pre>
	 * \bhA͂܂܂B
	 * </pre>
	 * @param args 
	 */
	public static void main(String[] args){

		// AvP[VN܂
		launch(args);

	} // end main

	/**
	 * X^[g
	 * <pre>
	 * s܂B
	 * </pre>
	 */
	@Override
	public void start(Stage primaryStage){

		// yC𐶐
		StackPane pane = new StackPane();

		// V[𐶐
		// Zobt@LɂiŌ̈Abooleanj
		Scene scene = new Scene(pane, 600, 200, true);

		// wiɂ
		scene.setFill(Color.BLACK);

		// V[ݒ
		primaryStage.setScene(scene);

		// ^Cgݒ
		primaryStage.setTitle("3D OBJ TEST 3");

		// EBhEۂɈSɏI
		primaryStage.setOnCloseRequest(req -> {
			// JavaFXAvP[VI
			Platform.exit();
			// ɏIĂȂXbhI
			System.exit(0);
		});

		// O[v𐶐
		Group panel3D = new Group();

		// TuV[𐶐
		SubScene scene3D = new SubScene(panel3D, 600, 200, true, null);

		// yCɒǉ
		pane.getChildren().add(scene3D);

		// Jݒ
		PerspectiveCamera camera = new PerspectiveCamera(true);

		// J̋Ԃݒ
		camera.setFarClip(300);

		// Jݒ
		scene3D.setCamera(camera);

		// ݒ
		PointLight light = new PointLight();

		// ʒu
		light.setTranslateX(-10);
		light.setTranslateY(-10);
		light.setTranslateZ(-10);

		// ݒ
		panel3D.getChildren().add(light);

		// ArGg
		AmbientLight ambientLight = new AmbientLight(Color.rgb(40, 40, 40));
		panel3D.getChildren().add(ambientLight);

		//
		// Box
		//

		// Box
		Box box = new Box(1.0, 1.0, 1.0);

		// }eA𐶐
		PhongMaterial materialBox = new PhongMaterial(Color.LIGHTPINK);

		// }eAݒ
		box.setMaterial(materialBox);

		// ]
		box.getTransforms().add(new Rotate(15, Rotate.Y_AXIS));
		box.getTransforms().add(new Rotate(30, Rotate.X_AXIS));

		// ʒuύX
		box.setTranslateX(-2.0);
		box.setTranslateZ(4.0);

		// Boxǉ
		panel3D.getChildren().add(box);

		//
		// Cylinder
		//

		// Cylinder
		Cylinder cylinder = new Cylinder(0.5, 2.0, 0);

		// }eA𐶐
		PhongMaterial materialCylinder = new PhongMaterial(Color.LIGHTGREEN);

		// }eAݒ
		cylinder.setMaterial(materialCylinder);

		// ]
		cylinder.getTransforms().add(new Rotate(30, Rotate.Y_AXIS));
		cylinder.getTransforms().add(new Rotate(90, Rotate.X_AXIS));

		// ʒuύX
		cylinder.setTranslateX(0.2);
		cylinder.setTranslateZ(4.0);

		// Cylinderǉ
		panel3D.getChildren().add(cylinder);

		//
		// Sphere
		//

		// Sphere
		Sphere sphere = new Sphere(0.6, 0);

		// }eA𐶐
		PhongMaterial materialSphere = new PhongMaterial(Color.LIGHTBLUE);

		// }eAݒ
		sphere.setMaterial(materialSphere);

		// ʒuύX
		sphere.setTranslateX(2.0);
		sphere.setTranslateZ(4.0);

		// Sphereǉ
		panel3D.getChildren().add(sphere);

		// EBhE\
		primaryStage.show();

	} // end start

}
